#include <stdio.h>
#include <ctype.h>

#define a_MIN_A 'a' - 'A'

struct pos {
    int x;
    int y;
};

pos figs[8][2];
pos pows[8][2];

int posfig[256];
int lastpow[2];
char names[] = { 'K', 'Q', 'R', 'R', 'B', 'B', 'N', 'N' }; 

int main(void) {
    char str[500];
    int ch;
    int isBlack;
    struct pos *act;
    
    posfig['K'] = 0;
    posfig['Q'] = 1;
    posfig['R'] = 2;
    posfig['B'] = 4;
    posfig['N'] = 6;
    lastpow[0] = lastpow[1] = 0;
    
    for (int i = 0; i < 8; ++i)
	for (int j = 0; j < 2; ++j) {
	    figs[i][j].x = -1;
	    pows[i][j].x = -1;
	}
    
    for (int i = 0; i < 8; ++i) {
	scanf("%s", str);
	//printf("_0_%c_ ", getchar());
	getchar();
	for (int j = 0; j < 8; ++j) {
	    //printf("_1_%c_ ", getchar());
	    //printf("_2_%c_ ", getchar());
	    getchar();
	    getchar();
	    ch = getchar();
	    if ((ch == '.') || (ch == ':')) {
		//printf("_3_%c_ ", getchar());
		getchar();
		continue;
	    }
	    if (islower(ch)) {
		isBlack = 1;
		ch -= a_MIN_A;
	    } else {
		isBlack = 0;
	    }
	    if (ch == 'P') {
		act = &pows[lastpow[isBlack]++][isBlack];
		//printf("P %d, %d %d\n", i, j, isBlack);
	    } else {
		if (figs[posfig[ch]][isBlack].x == -1) {
		    act = &figs[posfig[ch]][isBlack];
		} else {
		    act = &figs[posfig[ch]+1][isBlack];
		}
	    }
	    act->x = j;
	    act->y = i;
	    //printf("_4_%c_ ", getchar());
	    getchar();
	}
	while ((ch = getchar()) != '\n');
    }
    
    
    for (int j = 0; j < 2; ++j) {
	printf("%s: ", (j) ? "Black" : "White");
	
	bool first = true;
	
	for (int i = 0; i < 8; ++i) {
	    if (figs[i][j].x != -1) {
		if (!first) printf(",");
		printf("%c%c%d", names[i], figs[i][j].x + 'a', 8 - figs[i][j].y);
		first = false;
	    }
	}
	

	for (int i = 0; i < 8; ++i) {
	    if (pows[i][j].x != -1) {
        	if (!first) printf(",");
		//printf("%d %d", pows[i][j].x , pows[i][j].y);
		printf("%c%d", pows[i][j].x + 'a', 8 - pows[i][j].y);
		first = false;
	    }
	}
	printf("\n");
    }
    
    return 0;
}
